GuildShoppingList = LibStub("AceAddon-3.0"):NewAddon("GuildShoppingList", "AceConsole-3.0", "AceEvent-3.0")
AceGUI = LibStub("AceGUI-3.0")
AceConfig = LibStub("AceConfig-3.0")

-- "Devoted to Aceras, the darnedest worst mage in Azeroth"

GuildShoppingListOptionsTable = {
	type = "group",
	args = {
		setup = {
			type = "execute",
			name = "Setup GSL",
			desc = "Instructions on how to set up GSL",
			func = function() GuildShoppingList:explainHowTo(); end,
			
		},
		self = {
			type = "execute",
			name = "reset to the default config",
			desc = "Posts the current guild tab information to your chat frame.",
			func = function() GuildShoppingList:gslSlashProc(); end,
		},
		guild = {
			type = "execute",
			name = "Post to guild",
			desc = "Post report into the guild channel",
			func = function(channel) GuildShoppingList:gsl__rgSlashProc("GUILD"); end,
			
		},
		party = {
			type = "execute",
			name = "Post to party",
			desc = "Post report into the party channel",
			func = function(channel) GuildShoppingList:gsl__rgSlashProc("PARTY"); end,
			
		},
		raid = {
			type = "execute",
			name = "Post to raid",
			desc = "Post report into the raid channel",
			func = function(channel) GuildShoppingList:gsl__rgSlashProc("RAID"); end,
			
		},
		say = {
			type = "execute",
			name = "Post to say",
			desc = "Post report into the say channel",
			func = function(channel) GuildShoppingList:gsl__rgSlashProc("SAY"); end,
			
		},
	}
}

function GuildShoppingList:OnInitialize()
    -- Called when the addon is loaded
    AceConfig:RegisterOptionsTable("GuildShoppingList", GuildShoppingListOptionsTable, {"gsl"})
end

function GuildShoppingList:OnEnable()
    -- Called when the addon is enabled
   --self:RegisterChatCommand("gsl", "gslSlashProc")
   --self:RegisterChatCommand("gslrg", "gsl__rgSlashProc")
   self:Print("currently in alpha stages, testing by round table @ alonsus")
   if isMacClient() then self:Print("We love you, because your a mac user (:") end
end

local function GSL__InGuildBank(itemID)
	local itemCount = 0 

	for tab = 1, GetNumGuildBankTabs() do
		for slot = 1, 98 do
			itemLink = GetGuildBankItemLink(tab, slot)
			if itemLink and itemLink:match("item:(%d+)") == itemID then
				itemCount = itemCount + select(2, GetGuildBankItemInfo(tab, slot))
			end
		end
	end
	return itemCount
end

function GuildShoppingList:explainHowTo()
	-- Returns how to setup GuildShoppingList in the default chat frame
	local instructions = "If you have access to edit the info tab of the guild bank, then add the code -- GSL -- {itemid:qty} -- ENDGSL --, to the tab you wish GSL to process information for.
	Then for each item you wish GSL to track, change itemid to the id of the item you wish to track (you can obtain this from wowhead or any itemid tracking add-on) and change qty to the numerical value of the total amount of the item you need (not in stacks). Save the changes and your done!"
	self:Print(instructions)	
end


function GuildShoppingList:gslSlashProc()
    -- Actions to be taken when command /gsl is procced.
    BankTab = GetCurrentGuildBankTab()
    BankInfo = GetGuildBankText(BankTab)
    local Tabname, Tabicon, TabisViewable, TabcanDeposit, TabnumWithdrawals, remainingWithdrawals = GetGuildBankTabInfo(BankTab)
    p1 = BankInfo:match('%-%- GSL %-%-%s+(.*)%s+%-%- ENDGSL %-%-')
    if p1 then
    	if p1 ~= "" or "@ignoretab" then
	    	self:Print("Returning info for: "..Tabname..": "..p1)
		    for id,qty in p1:gmatch('(%d+):(%d+)') do
		     	--do something with those keys:
		    	local sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount = GetItemInfo(id);
		    	local in_guild = GSL__InGuildBank(id);
		    	-- do some magic maths
		    	local iSum = qty/iStackCount
		    	local iRemaining = qty-in_guild
		    	self:Print("We need "..sLink.." x"..qty.." total("..iSum.." stacks of "..iStackCount..") and we have "..iRemaining.." left to get")
			end
		else
			self:Print("GSL could not retrieve information Check the following errors:")
			self:Print("GSL is ignoring this tab, check the info tab to see if there are any requirements of the tab (will be marked by -- GSL -- <data> -- ENDGSL --")
		end
	else
	    self:Print("GSL could not retrieve information Check the following errors:")
	    self:Print("GSL has not yet read the info tab in the guild bank. Open the guild bank and select the info tab to allow GSL to read this.")
	end
end

function GuildShoppingList:gsl__rgSlashProc(channel)
    -- Actions to be taken when command /gsl rg is procced.
    BankTab = GetCurrentGuildBankTab()
    BankInfo = GetGuildBankText(BankTab)
    local Tabname, Tabicon, TabisViewable, TabcanDeposit, TabnumWithdrawals, remainingWithdrawals = GetGuildBankTabInfo(BankTab)
    p1 = BankInfo:match('%-%- GSL %-%-%s+(.*)%s+%-%- ENDGSL %-%-')
    if p1 then
    	if p1 ~= "" or "@ignoretab" then
	    	self:Print("Returning info for: "..Tabname..": "..p1)
		    for id,qty in p1:gmatch('(%d+):(%d+)') do
		     	--do something with those keys:
		    	local sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount = GetItemInfo(id);
		    	local in_guild = GSL__InGuildBank(id);
		    	-- do some magic maths
		    	local iSum = qty/iStackCount
		    	local iRemaining = qty-in_guild
		    	SendChatMessage("We need "..sLink.." x"..qty.." total("..iSum.." stacks of "..iStackCount..") and we have "..iRemaining.." left to get", channel)
			end
		elseif p1 == "@ignoretab" then
			self:Print("GSL could not retrieve information Check the following errors:")
			self:Print("GSL is ignoring this tab, check the info tab to see if there are any requirements of the tab (will be marked by -- GSL -- <data> -- ENDGSL --")
		end
	else
	    self:Print("GSL could not retrieve information Check the following errors:")
	    self:Print("GSL has not yet read the info tab in the guild bank. Open the guild bank and select the info tab to allow GSL to read this.")
	end
end


-- api usage
-- GetItemIcon(itemid) gets the item from the item id provided by the key.
-- GetItemInfo(itemId or "itemString" or "itemName" or "itemLink") - Returns information about an item.